@echo off
cd /d "%~dp0"
color 0b
title LocalTracker / Starting...

set RUNCOUNT=0

for %%a in (nc.--- magic.bin) do if not exist %%a (
	title LocalTracker / Error
	echo %%a is missing.
	goto exit
)

if not "%1"=="" (
	echo Ignoring command-line parameter^(s^): "%*"
)

echo Running connection test...
rem TODO: check that the port binding isn't already in use by another program, but that's very unlikely for 127.0.0.1:58103.
start /b nc.--- -l -p 58103 -s 127.0.0.1 -n -z -d 1>nul 2>&1
nc.--- -n -w 1 -z 127.0.0.1 58103 1>nul 2>&1

if %ERRORLEVEL% EQU 0 (
	echo ...done.
	cls
	goto main
) else (
	title LocalTracker / Error
	echo ...failed! You may need to whitelist nc.--- in your firewall or
	echo antivirus, and/or run this script with administrator privileges.
	echo.
	echo To run with administrator privileges:
	echo   * Right-click on %~nx0
	echo   * Click on "Run as administrator"
	echo   * Click on "Yes" in the User Account Control prompt
	echo.
	echo To whitelist the program in your firewall or antivirus, refer to its
	echo documentation.
	echo.
	taskkill /f /im nc.--- 1>nul 2>&1
	goto exit
)

:main
title LocalTracker / Ready
echo Before starting, make sure you're able to capture packets on the
echo localhost interface. The following methods have been tested:
echo   * Wireshark (wireshark.org) with Npcap (nmap.org/npcap); select the
echo     "Adapter for loopback traffic capture". Optionally use "tcp port
echo     58103" as a capture filter or "tcp.port == 58103" as a display one
echo     to hide unrelated packets.
echo   * SmartSniff (nirsoft.net/utils/smsniff.html) with Npcap; select
echo     "WinPcap Packet Capture Driver" as the capture method and "Adapter
echo     for loopback traffic capture" as the adapter. You may have to
echo     enable promiscuous mode. Optionally use "include:remote:tcp:58103"
echo     as a capture or display filter to hide unrelated packets.
echo   * RawCap (netresec.com/?page=RawCap); select the "127.0.0.1/Loopback
echo     Pseudo-Interface 1", then import the output .pcap file in any
echo     compatible program after finishing the capture.
echo After you start the local tracker, load any of the included test
echo torrents on your client, or add this announce URL to existing ones:
echo.
echo     http://127.0.0.1:58103/announce
echo.
echo Note that multiple simultaneous connections are not allowed, and may
echo cause requests to be lost. To exit, press Ctrl+C and then 'Y' or simply
echo close this window.
echo.

:prompt
choice /c yn /n /m "Do you want to start now? (y/n)"
if %ERRORLEVEL%==1 echo Okay, continuing.&echo.&goto loop
if %ERRORLEVEL%==2 title LocalTracker / Done&goto exit
echo Invalid choice, press a key and try again.
pause >nul
goto prompt

:loop
set /a RUNCOUNT=%RUNCOUNT%+1
title LocalTracker / Running / Round #%RUNCOUNT%
echo * Waiting for announce (round #%RUNCOUNT%)...
nc.--- -l -p 58103 -s 127.0.0.1 -n <"magic.bin" 1>nul 2>&1
goto loop

:exit
set RUNCOUNT=
echo Press any key to exit...
pause >nul
exit /b
